<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 https://maven.apache.org/xsd/maven-4.0.0.xsd">
	<modelVersion>4.0.0</modelVersion>
	<groupId>org.kar</groupId>
	<artifactId>karideo</artifactId>
	<version>0.3.0</version>
	<properties>
		<maven.compiler.version>3.13.0</maven.compiler.version>
		<maven.compiler.source>23</maven.compiler.source>
		<maven.compiler.target>23</maven.compiler.target>
		<maven.dependency.version>3.1.1</maven.dependency.version>
	</properties>
	<repositories>
		<repository>
			<id>gitea</id>
			<url>https://gitea.atria-soft.org/api/packages/kangaroo-and-rabbit/maven</url>
		</repository>
	</repositories>
	<dependencies>
		<dependency>
			<groupId>kangaroo-and-rabbit</groupId>
			<artifactId>archidata</artifactId>
			<version>0.24.0</version>
		</dependency>
		<!-- Loopback of logger JDK logging API to SLF4J -->
		<dependency>
			<groupId>org.slf4j</groupId>
			<artifactId>jul-to-slf4j</artifactId>
			<version>2.0.9</version>
		</dependency>
		<!-- generic logger of SLF4J to console (in color) -->
		<dependency>
			<groupId>ch.qos.logback</groupId>
			<artifactId>logback-classic</artifactId>
			<version>1.4.11</version>
		</dependency>
		<dependency>
			<groupId>xerces</groupId>
			<artifactId>xercesImpl</artifactId>
			<version>2.12.2</version>
		</dependency>
		<dependency>
			<groupId>org.codehaus.janino</groupId>
			<artifactId>janino</artifactId>
			<version>3.1.9</version>
		</dependency>
		<dependency>
			<groupId>com.fasterxml.jackson.datatype</groupId>
			<artifactId>jackson-datatype-jsr310</artifactId>
			<version>2.18.1</version>
		</dependency>
		<!--
		************************************************************ 
		** TEST dependency                                        **
		************************************************************
		-->
		<dependency>
			<groupId>org.junit.jupiter</groupId>
			<artifactId>junit-jupiter-api</artifactId>
			<version>5.11.0</version>
			<scope>test</scope>
		</dependency>
		<dependency>
			<groupId>org.junit.jupiter</groupId>
			<artifactId>junit-jupiter-engine</artifactId>
			<version>5.11.0</version>
			<scope>test</scope>
		</dependency>
		<dependency>
			<groupId>net.revelc.code.formatter</groupId>
			<artifactId>formatter-maven-plugin</artifactId>
			<version>2.24.1</version>
		</dependency>
		<dependency>
			<groupId>org.apache.maven.plugins</groupId>
			<artifactId>maven-checkstyle-plugin</artifactId>
			<version>3.5.0</version>
		</dependency>
	</dependencies>
	<build>
		<sourceDirectory>src</sourceDirectory>
		<testSourceDirectory>test/src</testSourceDirectory>
		<directory>${project.basedir}/out/maven/</directory>
		<resources>
			<resource>
				<directory>src/resources</directory>
			</resource>
		</resources>
		<testResources>
			<testResource>
				<directory>${basedir}/test/resources</directory>
			</testResource>
		</testResources>
		<plugins>
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-compiler-plugin</artifactId>
				<version>${maven.compiler.version}</version>
				<configuration>
					<source>${maven.compiler.source}</source>
					<target>${maven.compiler.target}</target>
				</configuration>
			</plugin>
			<plugin>
				<groupId>org.codehaus.mojo</groupId>
				<artifactId>exec-maven-plugin</artifactId>
				<version>3.2.0</version>
				<executions>
					<execution>
						<id>prod-mode</id>
						<goals>
							<goal>java</goal>
						</goals>
						<configuration>
							<mainClass>org.kar.karideo.WebLauncher</mainClass>
						</configuration>
					</execution>
					<execution>
						<id>dev-mode</id>
						<goals>
							<goal>java</goal>
						</goals>
						<configuration>
							<mainClass>org.kar.karideo.WebLauncherLocal</mainClass>
						</configuration>
					</execution>
					<execution>
						<id>generate-api</id>
						<goals>
							<goal>java</goal>
						</goals>
						<configuration>
							<mainClass>org.kar.karideo.GenerateApi</mainClass>
						</configuration>
					</execution>
				</executions>
				<configuration>
					<mainClass/>
				</configuration>
			</plugin>
			<!-- Create the source bundle -->
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-source-plugin</artifactId>
				<version>4.0.0-beta-1</version>
				<executions>
					<execution>
						<id>attach-sources</id>
						<goals>
							<goal>jar</goal>
						</goals>
					</execution>
				</executions>
			</plugin>
			<!-- junit results -->
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-surefire-plugin</artifactId>
				<version>3.2.5</version>
			</plugin>
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-assembly-plugin</artifactId>
				<version>3.7.1</version>
				<configuration>
					<archive>
						<manifest>
							<mainClass>fully.qualified.MainClass</mainClass>
						</manifest>
					</archive>
					<descriptorRefs>
						<descriptorRef>jar-with-dependencies</descriptorRef>
					</descriptorRefs>
				</configuration>
			</plugin>
			<!-- Java-doc generation for stand-alone site -->
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-javadoc-plugin</artifactId>
				<version>3.3.0</version>
				<configuration>
					<show>private</show>
					<nohelp>true</nohelp>
				</configuration>
			</plugin>
			<!-- Check the style of the code -->
			<plugin>
				<groupId>net.revelc.code.formatter</groupId>
				<artifactId>formatter-maven-plugin</artifactId>
				<version>2.24.1</version>
				<configuration>
					<encoding>UTF-8</encoding>
					<lineEnding>LF</lineEnding>
					<configFile>Formatter.xml</configFile>
					<directories>
						<directory>src/</directory>
						<directory>test/src</directory>
					</directories>
					<includes>
						<include>**/*.java</include>
					</includes>
					<excludes>
						<exclude>module-info.java</exclude>
					</excludes>
				</configuration>
				<executions>
					<execution>
						<goals>
							<goal>validate</goal>
						</goals>
					</execution>
				</executions>
			</plugin>
			<plugin>
				<groupId>com.github.spotbugs</groupId>
				<artifactId>spotbugs-maven-plugin</artifactId>
				<version>4.8.5.0</version>
				<configuration>
					<includeFilterFile>spotbugs-security-include.xml</includeFilterFile>
					<excludeFilterFile>spotbugs-security-exclude.xml</excludeFilterFile>
				</configuration>
			</plugin>
		</plugins>
	</build>
	<!-- Generate Java-docs As Part Of Project Reports -->
	<reporting>
		<plugins>
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-javadoc-plugin</artifactId>
				<version>3.3.0</version>
				<configuration>
					<show>public</show>
				</configuration>
			</plugin>
		</plugins>
	</reporting>
</project>
